#include <Xm/MessageB.h>
#include <Xm/RowColumn.h>
#include <Xm/Form.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/Frame.h>
#include <Xm/LabelG.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string.h>
#include <math.h>
#include "global.h"
#include "messages.h"
#include "nrutil.h"

/* Structure for Mann-Whitney U-tests */
typedef struct {
  int  nlist1, nlist2;
  int  *list1, *list2;
  int  umw_group_var;
} utest_struct;

void nonpara_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  static utest_struct  *utest;
  static Widget list_w[3];
  Widget        toplevel, dialog, rc, w;
  Arg           args[5];
  String        **cells, *clabels;
  int           rows, cols;
  int           item, i, j;
  XmStringTable dep_list;
  int           dep_count;
  short         is_sort;

  /* not used so far;
  Widget        form, add1_w, add2_w, rem1_w, rem2_w;
  int           k;
  int           n, startgroup;
  float         *data, wert;
  float         ave, adev, sdev, var, skew, curt, min, max;
  float         *data1, *data2, wert1, wert2;
  float         sx, sy, sx2, sy2, sxy;
  float         qx, qy, qxy;
  float         r, r2, by, bx, ay, ax, s2yx, s2xy;
  char          *pcells1, *pcells2;
  char          temp[256], text[256], *pcells;
  char          *out_buf;

  extern void moment(float data[], unsigned long n,
		     float *ave, float *adev, float *sdev, float *var,
		     float *skew, float *curt);
  extern float prho(int n, float is, int *ifault);
  void ptt_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void add1_ptt_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void add2_ptt_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void rem1_ptt_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void rem2_ptt_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void utt_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void group_utt_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void elem_utt_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  end of not used so far; */

  extern void cancel_cb(Widget, XtPointer, XtPointer);
  extern void showmess(Widget widget, char *title, char *text);
  void group_umw_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void umw_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data);

  toplevel=XtParent(widget);
  while (!XtIsTopLevelShell(toplevel)) toplevel=XtParent(toplevel);
  item=(int) client_data;

  //  out_buf=new char  [OUTBUFLEN]; strcpy(out_buf,"");
  //  data   =new float [DATALEN];
  //  data1  =new float [DATALEN];
  //  data2  =new float [DATALEN];
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNrows, &rows, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &clabels, NULL);
  XtVaGetValues(StatData, XmNcells, &cells, NULL);
  if (!utest) {
    utest=new utest_struct;
    utest->nlist1=0; utest->nlist2=0;
    utest->list1=new int[1];
    utest->list2=new int[1];
    utest->umw_group_var=0;
  }

  switch(item) {
  case 0:      // Wilcoxon-test;
    showmess(StatData, NOT_IMPLEMENTED_T, NOT_IMPLEMENTED_M);    
    break;
  case 1:      // Mann and Whitney (U-test);
    if (sort.ndep>0) {
      i=0;
      XtSetArg(args[i], XmNdialogTitle,
	       XmStringCreateLocalized("Mann-Whitney U-test"));
      i++;
      XtSetArg(args[i], XmNmessageString,
	       XmStringCreateLtoR("1. Select one variable that defines the two groups.\n2. Select two levels for comparison.",XmFONTLIST_DEFAULT_TAG));
      i++;
      XtSetArg(args[i], XmNautoUnmanage, False); i++;
      dialog=XmCreateMessageDialog(toplevel, "dialog", args, i);
      XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_HELP_BUTTON));
      XtVaSetValues(dialog,
		    XmNheight, 350,
		    XmNuserData, utest,
		    NULL);
      rc=XtVaCreateWidget("rc", xmRowColumnWidgetClass, dialog,
			  XmNorientation, XmHORIZONTAL,
			  NULL);
      /* create list for selection of group variable  */
      if (cols-sort.nsort-sort.ndep>0) {
	dep_list=(XmStringTable)XtMalloc((cols-sort.nsort-sort.ndep)
					 * sizeof(XmString));
	dep_count=0;
	for (i=0; i<cols; i++) {
	  is_sort=0;
	  for (j=0; j<sort.nsort; j++) if (i==sort.sort[j]) is_sort=1;
	  for (j=0; j<sort.ndep; j++)  if (i==sort.dep[j]) is_sort=1;
	  if (!is_sort) {
	    dep_list[dep_count]=XmStringCreateLocalized(clabels[i]);
	    dep_count++;
	  }
	}
      }
      w=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				XmNshadowType, XmSHADOW_OUT,
				NULL);
      XtVaCreateManagedWidget("group variable", xmLabelGadgetClass, w,
			      XmNchildType, XmFRAME_TITLE_CHILD,
			      XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			      XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			      NULL);
      list_w[1]=XmCreateScrolledList(w, "deplist", NULL, 0);
      XtVaSetValues(list_w[1],
		    XmNchildType, XmFRAME_WORKAREA_CHILD,
		    XmNselectionPolicy, XmSINGLE_SELECT,
		    XmNuserData, utest,
		    NULL);
      if (cols-sort.nsort-sort.ndep>0) {
	XtVaSetValues(list_w[1],
		      XmNitemCount, (cols-sort.nsort-sort.ndep),
		      XmNitems, dep_list,
		      NULL);
      }
      w=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				XmNshadowType, XmSHADOW_OUT,
				NULL);
      XtVaCreateManagedWidget("levels of group variable", xmLabelGadgetClass, w,
			      XmNchildType, XmFRAME_TITLE_CHILD,
			      XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			      XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			      NULL);
      list_w[2]=XmCreateScrolledList(w,"sortlist", NULL, 0);
      XtVaSetValues(list_w[2],
		    XmNchildType, XmFRAME_WORKAREA_CHILD,
		    XmNselectionPolicy, XmMULTIPLE_SELECT,
		    NULL);
      XtAddCallback(list_w[1], XmNsingleSelectionCallback, group_umw_cb, list_w);
      XtVaGetValues(list_w[1], XmNitemCount, &dep_count, NULL);
      if (dep_count>0) XmListSelectPos(list_w[1], 1, True);
      XtManageChild(list_w[1]);
      XtManageChild(list_w[2]);
      XtManageChild(rc);
      XtAddCallback(dialog, XmNokCallback, umw_ok_cb, list_w);
      XtAddCallback(dialog, XmNcancelCallback, cancel_cb, list_w);
      XtManageChild(dialog);
      XtPopup(XtParent(dialog), XtGrabNone);
      if (cols-sort.nsort-sort.ndep > 0) {
	for (i=0; i<(cols-sort.nsort-sort.ndep); i++) XmStringFree(dep_list[i]);
	XtFree((char *)dep_list);
      }
    }
    else {
      showmess(StatData, UMW_NOVAR_T, UMW_NOVAR_M);
    }
    break;
  }

  //  delete [] out_buf;
  //  delete [] data;
}


/* ..................................*/
/* .....   C a l l b a c k s   ..... */
/* ................................. */

void group_umw_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  XmListCallbackStruct *cbs=(XmListCallbackStruct *) call_data;
  Widget               *list_w, toplevel;
  utest_struct         *utest;
  String               **cells, *clabels;
  char                 *text;
  short                is_new;
  int                  i, j, cols, rows, group_n, elem_n;

  extern void showmess(Widget widget, char *title, char *text);

  list_w=(Widget *)client_data;
  XtVaGetValues(widget, XmNuserData, &utest, NULL);
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNrows, &rows, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &clabels, NULL);
  XtVaGetValues(StatData, XmNcells, &cells, NULL);
  toplevel=XtParent(widget);
  while (!XtIsTopLevelShell(toplevel)) toplevel=XtParent(toplevel);

  XmStringGetLtoR(cbs->item, XmFONTLIST_DEFAULT_TAG, &text);
  group_n=-1;
  for (i=0; i<cols; i++) {
    if (!strcmp(text, clabels[i])) group_n=i;
  }
  utest->umw_group_var=group_n;
  XtFree(text);

  if (rows>0) {
    XmListDeleteAllItems(list_w[2]);
    if (strtok(cells[0][group_n]," \t\n\0"))
      XmListAddItem(list_w[2],XmStringCreateLocalized(cells[0][group_n]),0);
    for (i=1; i<rows; i++) {
      is_new=1;
      for (j=0; j<i; j++) {
	if (!strcmp(cells[i][group_n],cells[j][group_n])) is_new=0;
      }
      if (is_new)
	if (strtok(cells[i][group_n]," \t\n\0"))
	  XmListAddItem(list_w[2],XmStringCreateLocalized(cells[i][group_n]),0);
    }
  }
  XtVaGetValues(list_w[2], XmNitemCount, &elem_n, NULL);
  if (elem_n<2) showmess(toplevel, UTT_GERR_T, UTT_GERR_M);
  else {
    XmListSelectPos(list_w[2],1,False);
    XmListSelectPos(list_w[2],2,False);
  }
}

void umw_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget               *list_w;
  utest_struct         *utest;
  String               **cells, *clabels;
  XmString             *select_list;
  String               e1, e2;
  char                 *out_buf, *temp, *pcells, text[256];
  int                  cols, rows, select_n, *select_pos, startgroup;
  int                  k, i, j, m;
  int                  ndata1, ndata2, ss, nsmall;
  float                *data[3], sr, mr, vr, z, p;

  extern void showmess(Widget widget, char *title, char *text);
  extern void add_line(char *text, int n);
  extern void resedit(char *text, char *title);
  extern float alnorm(float x, int upper);
  void sortdata3(int n, float *data[3]);
  void rankdata3(int n, float *data[3]);

  list_w=(Widget *)client_data;
  XtVaGetValues(widget, XmNuserData, &utest, NULL);
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNrows, &rows, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &clabels, NULL);
  XtVaGetValues(StatData, XmNcells, &cells, NULL);
  out_buf=new char [OUTBUFLEN];
  temp   =new char [256];

  if (XmListGetSelectedPos(list_w[2], &select_pos, &select_n)) {
    if (select_n != 2)
      showmess(widget, UTT_SELERR_T, UTT_SELERR_M);
    else {
      /* now calculate Mann-Whitney U-test */
      XtVaGetValues(list_w[2], XmNitems, &select_list, NULL);
      XmStringGetLtoR(select_list[select_pos[0]-1],XmFONTLIST_DEFAULT_TAG, &e1);
      XmStringGetLtoR(select_list[select_pos[1]-1],XmFONTLIST_DEFAULT_TAG, &e2);
      strcpy(out_buf, "Mann-Whitney U-test \n");
      sprintf(temp, "Group 1: %s = %s \n", clabels[utest->umw_group_var], e1);
      strcat(out_buf, temp);
      sprintf(temp, "Group 2: %s = %s \n\n", clabels[utest->umw_group_var], e2);
      strcat(out_buf, temp);
      if (sort.ngroup==1) sort.group[0]=rows;
      startgroup=0;
      for (k=0; k<sort.ngroup; k++) {
	/* Headline */
	for (i=0; i<sort.nsort; i++) {
	  sprintf(temp, "%10s = %10s \n", clabels[sort.sort[i]], cells[startgroup][sort.sort[i]] );
	  strcat(out_buf, temp);
	}
	add_line(out_buf, 70);
	sprintf(temp,
		"%10s %4s %4s %9s %9s %9s %9s %9s\n",
		" ", "n1", "n2", "R", "mean", "std", "z", "P");
	strcat(out_buf, temp);
	add_line(out_buf, 70);
	/* Results */
	for (i=0; i<3; i++) data[i]=new float[sort.group[k]];
	for (i=0; i<sort.ndep; i++) {  // circle through dependent vars;
	  if (sort.dep[i]!=utest->umw_group_var) {  // group var. is not a depend. var;
	    ndata1=0; ndata2=0;
	    // get data array;
	    for (j=startgroup; j<startgroup+sort.group[k]; j++) {
	      if (!strcmp(cells[j][utest->umw_group_var], e1)) {
		data[0][ndata1+ndata2]=strtod(cells[j][sort.dep[i]], &pcells);
		data[1][ndata1+ndata2]=1;
		data[2][ndata1+ndata2]=0;
		// is it numeric ? ;
		if (data[0][ndata1+ndata2]!=0 || strcmp(pcells,cells[j][sort.dep[i]]))
		  ndata1++;
	      }
	      if (!strcmp(cells[j][utest->umw_group_var], e2)) {
		data[0][ndata1+ndata2]=strtod(cells[j][sort.dep[i]], &pcells);
		data[1][ndata1+ndata2]=2;
		data[2][ndata1+ndata2]=0;
		// is it numeric ? ;
		if (data[0][ndata1+ndata2]!=0 || strcmp(pcells,cells[j][sort.dep[i]]))
		  ndata2++;
	      }
	    }
	    // calculate U-test;
	    strncpy(text, clabels[sort.dep[i]], 10); text[10]='\0';
	    if (ndata1>=1 && ndata2>=1) {
	      /* sort data by data[0] */
	      sortdata3((ndata1+ndata2), data);
	      /* Assign ranks */
	      rankdata3((ndata1+ndata2), data);
	      /* Add the ranks of the smaller sample */
	      if (ndata1<=ndata2) ss=1;
	      else ss=2;
	      sr=0;
	      for (m=0; m<(ndata1+ndata2); m++) if (data[1][m]==ss) sr+=data[2][m];
	      /* Calculate mean and var of the distribution */
	      if (ndata1<=ndata2) nsmall=ndata1; else nsmall=ndata2;
	      mr=nsmall*(ndata1+ndata2+1)/2;
	      vr=ndata1*ndata2*(ndata1+ndata2+1)/12;
	      /* Calculate z and p */
	      z=(sr-mr)/sqrt(vr);
	      p=alnorm(fabs(z), TRUE);

	      sprintf(temp, "%10s %4d %4d %9.3f %9.3f %9.3f %9.3f %9.3f\n",
		      text, ndata1, ndata2, sr, mr, sqrt(vr), z, p);
	      strcat(out_buf, temp);
	    }
	    else {
	      sprintf(temp, "%10s %4d %4d\n", text, ndata1, ndata2);
	      strcat(out_buf, temp);
	    }
	    add_line(out_buf, 70);
	  }
	}
	for (i=0; i<3; i++) delete[]data[i];
	startgroup+=sort.group[k];
	strcat(out_buf, "\n");
      }
      resedit(out_buf, "Mann-Whitney U-test");
      XtFree(e1); XtFree(e2);
      XtUnmanageChild(widget);
    }
    XtFree((char *)select_pos);
  }
  else {
    showmess(widget, UTT_SELERR_T, UTT_SELERR_M);
  }
  delete[]temp;
  delete[]out_buf;
}


void sortdata3(int n, float *data[3]) {
  int   i, j;
  float a, b, c;

  for (j=1; j<n; j++) {
    a=data[0][j];
    b=data[1][j];
    c=data[2][j];
    i=j-1;
    while (i>=0 && data[0][i]>a) {
      data[0][i+1]=data[0][i];
      data[1][i+1]=data[1][i];
      data[2][i+1]=data[2][i];
      i--;
    }
    data[0][i+1]=a;
    data[1][i+1]=b;
    data[2][i+1]=c;
  }
}

void rankdata3(int n, float *data[3]) {
  int   i, j, k;
  float r;

  for (i=0; i<n; i++) {
    /* how often does this value appear ? */
    j=i+1;
    while((j<n) && (data[0][i]==data[0][j])) j++;
    r=0;
    for (k=i; k<j; k++) r+=k;
    for (k=i; k<j; k++) data[2][k]=(r/(j-i))+1;
    i+=(j-i-1);
  }
}
